#!/usr/bin/python3
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
#
# Copyright (C) 2011-2012 Bryce Harrington <bryce@bryceharrington.org>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

from __future__ import absolute_import, print_function, unicode_literals

'''Command line options'''

from optparse import OptionParser

# TODO: re-run pylint on this
class OptionHandler(OptionParser):
    def __init__(self, opts, info):
        '''Creates an OptionParser instance for the options in this module'''
        self.options = opts
        option_list = []
        for item in self.options:
            option_list.append(item[0])
        OptionParser.__init__(
            self,
            option_list=option_list,
            version="%prog "+info.VERSION,
            epilog=info.SHORT_DESCRIPTION)


    def descriptions(self):
        '''Returns a list of dict objects mapping option name to description'''
        data = []
        for opt in self.options:
            opts = opt[0]._short_opts
            opts.extend(opt[0]._long_opts)
            item = {
                'opts': opts,
                'text': opt[1],
                }
            data.append(item)
        return data

    def parse_commandline(self):
        (opts, values) = self.parse_args()
        return opts

